import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class TDC_MRP_Statistic {

	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		Job job = Job.getInstance(conf, "TDC_MRP_Statistic");
		job.setJarByClass(TDC_MRP_Statistic.class);
		// TODO: specify a mapper
		//job.setMapperClass(Mapper.class);
		job.setMapperClass(TDCS_MRP_Mapper.class);
		// TODO: specify a reducer
		//job.setReducerClass(Reducer.class);
		job.setReducerClass(TDCS_MRP_Reducer.class);

		// TODO: specify output types
		/*
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(Text.class);
		*/
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(IntWritable.class);

		// TODO: specify input and output DIRECTORIES (not files)
		//FileInputFormat.setInputPaths(job, new Path("TDCS_MRP_Temp"));
		FileInputFormat.setInputPaths(job, new Path("TDCS_MRP"));
		//FileOutputFormat.setOutputPath(job, new Path("TDCS_MRP_Output"));
		
		FileSystem hdfs = FileSystem.get(conf);
		Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_Output"); 			
		FileOutputFormat.setOutputPath(job, outputPath);
			
		if(hdfs.exists(outputPath)) {
	  		hdfs.delete(outputPath, true);
	  	}

		if (!job.waitForCompletion(true))
			return;
	}

}
