/* jdwang@asia.edu.tw 2017.2.23
 * For Windoop Environment 
 * HADOOP_HOME ${eclipse_home}\..\hadoop
 * PATH %PATH%;${eclipse_home}\..\hadoop\bin
 */
package jdwang.hadoop;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class TDCS_MRP_Main_TimeInterval_Statistic_Windoop {
	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		Job job = Job.getInstance(conf, "TDCS_MRP_Main_TimeInterval_Statistic_Windoop");
		job.setJarByClass(TDCS_MRP_Main_TimeInterval_Statistic_Windoop.class);
		// TODO: specify a mapper
		//job.setMapperClass(Mapper.class); 
		//job.setMapperClass(TDCS_MRP_Mapper.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_1.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_2.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_3.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_4_Filter_StartEndGantyrID.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_4_Filter_WeekDay_StartEndGantyrID.class);
		job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_4_Filter_VehicleType_WeekDay_StartEndGantyrID.class);
		
		
		// TODO: specify a reducer
		//job.setReducerClass(Reducer.class); 
		//job.setReducerClass(TDCS_MRP_Reducer.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_1.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_2.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_3.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_4_Filter_StartEndGantyrID.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_4_Filter_Weekday_StartEndGantyrID.class);
		job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_4_Filter_VehicleType_Weekday_StartEndGantyrID.class);

		//job.setNumReduceTasks(10);   //reduce

		// TODO: specify output types
		///*
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(Text.class);
		//*/
		/*
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(IntWritable.class);
		*/
		// TODO: specify input and output DIRECTORIES (not files)
		FileInputFormat.setInputPaths(job, new Path("TDCS_MRP_Temp"));
		//FileInputFormat.setInputPaths(job, new Path("TDCS_MRP"));
		//FileOutputFormat.setOutputPath(job, new Path("TDCS_MRP_Output"));
		
		FileSystem hdfs = FileSystem.get(conf);
		Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_Temp_Output_VehicleTypes");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_Interval_Output");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_QantryID_Hour_Interval_Output");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_QantryID_Hour_Interval_Statistics_Output");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_QantryID_Hour_Interval_Statistics_FilterStratEndGantry_Output");
		
		
		FileOutputFormat.setOutputPath(job, outputPath);
			
		if(hdfs.exists(outputPath)) {
	  		hdfs.delete(outputPath, true);
	  	}
		/*
		if (!job.waitForCompletion(true))
			return;
			*/
		if(job.waitForCompletion(true))
	  	{
	  		System.out.println("Job Done!");
	  		System.exit(0);
	  	}
	  	else
	  	{
	  		System.out.println("Job Failed!");
	  		System.exit(1);
	  	}    
	}

}
