package jdwang.hadoop;

import java.io.IOException;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;

//public class TDCS_MRP_Mapper extends Mapper<LongWritable, Text, Text, Text> {
public class TDCS_MRP_Mapper extends Mapper<LongWritable, Text, Text, IntWritable> {

	private final static IntWritable one = new IntWritable(1);
	public void map(LongWritable ikey, Text ivalue, Context context) throws IOException, InterruptedException {
		/* input format 
		 * (05F0001N_00_M1_00)(GateID)(Direction:N or S)_Hour_M(TimeUnit)_TimeUnitIndex
		 * ##3##3##6## : ##TF##DF##PatternLength
		 * (2016-11-04_Thu_32#1#1 : (Date_WeekDay_VehicleType##TF##DF)
		05F0001N_00_M1_00 03F0150N_00_M1_01 03F0140N_00_M1_01 03F0116N_00_M1_02 01F0099N_00_M1_04 01F0061N_00_M1_06##3##3##6##(2016-11-04_Thu_32#1#1)(2016-11-25_Thu_32#1#1)(2016-12-17_Fri_32#1#1)
		05F0001N_00_M1_00 03F0150N_00_M1_01 03F0140N_00_M1_01 03F0116N_00_M1_03 01F0099N_00_M1_04 01F0061N_00_M1_07 01F0029N_00_M1_09 01F0017N_00_M1_10##3##3##8##(2016-11-16_Tue_32#1#1)(2016-12-12_Sun_32#1#1)(2016-12-20_Mon_32#1#1)
		05F0001N_00_M1_00 03F0150N_00_M1_01 03F0140N_00_M1_01 03F0116N_00_M1_03 01H0163S_00_M1_08 01H0206S_00_M1_10 01H0305S_00_M1_16 01H0334S_00_M1_18##3##3##8##(2016-11-25_Thu_31#1#1)(2016-12-25_Sat_32#1#1)(2017-01-07_Fri_31#1#1)
		*/
		String line = ivalue.toString();
    	String[] Items = line.split("##");
    	
    	String QantryID = Items[0];
    	
    	String[] QantryIDInfo = QantryID.split(" ");
    	
    	String QantryID_Pattern = "";
    	for (int i=0;i<QantryIDInfo.length;i++) {
    		String OneQantryID = QantryIDInfo[i].substring(0,8);
    		String Hour = QantryIDInfo[i].substring(9,11);
    		String Min = QantryIDInfo[i].substring(15,17);
    		QantryID_Pattern = QantryID_Pattern+"#"+OneQantryID;
    	} // End of  for (int i=0;i<GateInfo.length;i++)
    	Text PatternKey = new Text();
    	PatternKey.set(QantryID_Pattern);
    	context.write(PatternKey,one);
	} //End of public void map
} // End of public class TDCS_MRP_Mapper
