package jdwang.hadoop;
import java.io.IOException;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeMap;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Mapper.Context;

//public class TDCS_MRP_Mapper extends Mapper<LongWritable, Text, Text, Text> {
//public class TDCS_MRP_TimeInterval_Mapper_3 extends Mapper<LongWritable, Text, Text, IntWritable> {
public class TDCS_MRP_TimeInterval_Mapper_4_Filter_VehicleType_WeekDay_StartEndGantyrID extends Mapper<LongWritable, Text, Text, Text> {

	//private final static IntWritable one = new IntWritable(1);		
  	
	///*
  	private String StartQantryID = "05F0528N"; 
	private String EndQantryID = "05F0001N";
	//*/
	/*
	private String StartQantryID = "05F0000S"; 
	private String EndQantryID = "05F0494S";
	*/
	private int LengthQantryID = 6;
	public void map(LongWritable ikey, Text ivalue, Context context) throws IOException, InterruptedException {
		/* input format 
		 * (05F0001N_00_M1_00)(GateID)(Direction:N or S)_Hour_M(TimeUnit)_TimeUnitIndex
		 * ##3##3##6## : ##TF##DF##PatternLength
		 * (2016-11-04_Thu_32#1#1 : (Date_WeekDay_VehicleType##TF##DF)
		05F0001N_00_M1_00 03F0150N_00_M1_01 03F0140N_00_M1_01 03F0116N_00_M1_02 01F0099N_00_M1_04 01F0061N_00_M1_06##3##3##6##(2016-11-04_Thu_32#1#1)(2016-11-25_Thu_32#1#1)(2016-12-17_Fri_32#1#1)
		05F0001N_00_M1_00 03F0150N_00_M1_01 03F0140N_00_M1_01 03F0116N_00_M1_03 01F0099N_00_M1_04 01F0061N_00_M1_07 01F0029N_00_M1_09 01F0017N_00_M1_10##3##3##8##(2016-11-16_Tue_32#1#1)(2016-12-12_Sun_32#1#1)(2016-12-20_Mon_32#1#1)
		05F0001N_00_M1_00 03F0150N_00_M1_01 03F0140N_00_M1_01 03F0116N_00_M1_03 01H0163S_00_M1_08 01H0206S_00_M1_10 01H0305S_00_M1_16 01H0334S_00_M1_18##3##3##8##(2016-11-25_Thu_31#1#1)(2016-12-25_Sat_32#1#1)(2017-01-07_Fri_31#1#1)
		*/
		String line = ivalue.toString();
    	String[] Items = line.split("##");
    	
    	String QantryID = Items[0]; // Gantry_TimeStamp
    	String TF = Items[1]; 
    	String DF = Items[2];
    	String Length = Items[3];
    	String ClassFrequencyDistribution = Items[4];
    		
    	// (2016-11-25_Thu_31#1#1)(2016-12-25_Sat_32#1#1)(2017-01-07_Fri_31#1#1)
    	String [] ClassDistribution = ClassFrequencyDistribution.split("\\)");
    	
    	TreeMap WeekdayFreqDistribution = new TreeMap <String, Integer>();
    	TreeMap VehicleTypeFreqDistribution = new TreeMap <String, Integer>();
    	TreeMap VehicleType_Weekday_FreqDistribution = new TreeMap <String, Integer>();
    	
    	for (int i=0;i< ClassDistribution.length;++i ){
    		// (2016-11-25_Thu_31#1#1
    		String [] OneClassInfo = ClassDistribution[i].split("#");
    		String OneDate = OneClassInfo[0].substring(1,11);
    		String OneWeekday = OneClassInfo[0].substring(12,15);
    		String OneVehicleType = OneClassInfo[0].substring(16);
    		
    		int OneTF = Integer.valueOf(OneClassInfo[1]);
      		  
    		/*
        	 * Compute the "Weekday" frequency distribution
        	 */
    		if (WeekdayFreqDistribution.containsKey(OneWeekday)) {
				Integer temp = (int) WeekdayFreqDistribution.get(OneWeekday) + OneTF;
				WeekdayFreqDistribution.put(OneWeekday, temp);
			} else {
				WeekdayFreqDistribution.put(OneWeekday, OneTF);
			}
    		/*
        	 * Compute the "VehicleType" frequency distribution
        	 */
    		if (VehicleTypeFreqDistribution.containsKey(OneVehicleType)) {
				Integer temp = (int) VehicleTypeFreqDistribution.get(OneVehicleType) + OneTF;
				VehicleTypeFreqDistribution.put(OneVehicleType, temp);
			} else {
				VehicleTypeFreqDistribution.put(OneVehicleType, OneTF);
			}
    		/*
        	 * Compute the "VehicleType_Weekday" frequency distribution
        	 */
    		String OneCombinedType = OneVehicleType+" "+OneWeekday;
    		if (VehicleType_Weekday_FreqDistribution.containsKey(OneCombinedType)) {
				Integer temp = (int) VehicleType_Weekday_FreqDistribution.get(OneCombinedType) + OneTF;
				VehicleType_Weekday_FreqDistribution.put(OneCombinedType, temp);
			} else {
				VehicleType_Weekday_FreqDistribution.put(OneCombinedType, OneTF);
			}
    		
    	} // End of for (int i=0;i< ClassDistribution.length;++i )
    	
    	
    	/*
    	 * The information of first GantryID in one MRP
    	 * 05F0001N_00_M1_00 03F0150N_00_M1_01 03F0140N_00_M1_01 03F0116N_00_M1_02 01F0099N_00_M1_04 01F0061N_00_M1_06##3##3##6##(2016-11-04_Thu_32#1#1)(2016-11-25_Thu_32#1#1)(2016-12-17_Fri_32#1#1)
		
    	 */
		String[] QantryIDInfo = QantryID.split(" "); 
    	String FirstQantryID = QantryIDInfo[0].substring(0,8); // "05F0001N"_00_M1_00
    	String LastQantryID = QantryIDInfo[QantryIDInfo.length-1].substring(0,8);
    	
    	//if ((FirstQantryID.equals(StartQantryID))&&(LastQantryID.equals(EndQantryID)) ) {
    	if ((FirstQantryID.equals(StartQantryID))
    	  &&(LastQantryID.equals(EndQantryID))
    	  &&(LengthQantryID == QantryIDInfo.length)) {
        	
			String Hour = QantryIDInfo[0].substring(9,11); // 05F0001N_"00"_M1_00
	    	String FirstQantryID_Hour = Hour;
			String Min = QantryIDInfo[0].substring(15,17);
			int HourIndex = Integer.parseInt(FirstQantryID_Hour);
			int MinIndex = Integer.parseInt(Min);
			int OneDayMinIndex = HourIndex* 60 + MinIndex;
	
			// key ＝　＂QantryID_Pattern＂
			//String QantryID_Pattern = FirstQantryID+" "+FirstQantryID_Hour;
			
			int PreviousMinIndex = OneDayMinIndex;
			String TimeIntervalSeq = "";
			int NextMinIndex = 0;
			int TotalTime = 0;
			int MaxDayMinIndex = 24*60;
			/*
			 * Compute the series of travel time intervals among GantryID
			 * e.g. "05F0001N_00_M1_00"
			 */
			// Compute "TotalTime" of travel time intervals with one MRP
	    	for (int i=1;i<QantryIDInfo.length;i++) {
	    		String OneQantryID = QantryIDInfo[i].substring(0,8);
	    		Hour = QantryIDInfo[i].substring(9,11);
	    		Min = QantryIDInfo[i].substring(15,17);
	    		HourIndex = Integer.parseInt(Hour);
	    		MinIndex = Integer.parseInt(Min);
	    		OneDayMinIndex = HourIndex* 60 + MinIndex;
	    		
	    		int OneTimeInterval = OneDayMinIndex - PreviousMinIndex;	
	    		if (OneTimeInterval < 0) {
	    			OneTimeInterval = MaxDayMinIndex - PreviousMinIndex + OneDayMinIndex;
	    		}		
	    		TotalTime = TotalTime + OneTimeInterval;	
	    		//TimeIntervalSeq = TimeIntervalSeq + "#"+Integer.toString(OneTimeInterval);
	    		//QantryID_Pattern = QantryID_Pattern+"#"+OneQantryID;
	    		
	    		PreviousMinIndex = OneDayMinIndex;
	    	} // End of  for (int i=0;i<GateInfo.length;i++)
	    	
	    	
	    	
	    	Text PatternKey = new Text();
	    	Text ValueKey = new Text();
	    	
	    	//String WeekdayDistribution = "";
	    	/*
	    	Set <String> keys_VehicleTypes = VehicleTypeFreqDistribution.keySet();		
			for ( Iterator i1 = keys_VehicleTypes.iterator(); i1.hasNext();) {
			     String oneVehicleType =  (String) i1.next();
			     Integer value =  (Integer) VehicleTypeFreqDistribution.get(oneVehicleType);
			     String CompositeValue = "Total_Min="+Integer.toString(TotalTime)+"##"+value;	      			
			     
			     String Class_QantryID_Pattern = oneVehicleType + " "+FirstQantryID+" "+FirstQantryID_Hour;;
			     
			     PatternKey.set(Class_QantryID_Pattern);
			     ValueKey.set(CompositeValue);	
			     
			     context.write(PatternKey,ValueKey);			     			
			} // End of for ( Iterator i = Keys.iterator(); i.hasNext();)
			*/
	    	Set <String> keys_VehicleTypes_Weekday = VehicleType_Weekday_FreqDistribution.keySet();		
			for ( Iterator i1 = keys_VehicleTypes_Weekday.iterator(); i1.hasNext();) {
			     String onekeys_VehicleTypes_Weekday =  (String) i1.next();
			     Integer value =  (Integer) VehicleType_Weekday_FreqDistribution.get(onekeys_VehicleTypes_Weekday);
			     String CompositeValue = "Total_Min="+Integer.toString(TotalTime)+"##"+value;	      			
			     
			     String Class_QantryID_Pattern = onekeys_VehicleTypes_Weekday + " "+FirstQantryID+" "+FirstQantryID_Hour;;
			     
			     PatternKey.set(Class_QantryID_Pattern);
			     ValueKey.set(CompositeValue);	
			     
			     context.write(PatternKey,ValueKey);			     			
			} // End of for ( Iterator i = Keys.iterator(); i.hasNext();)
    	} // End of if ((FirstQantryID.equals(StartQantryID))&&(LastQantryID.equals(EndQantryID)) )    	
	} //End of public void map
} // End of public class TDCS_MRP_Mapper
